"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from exfunc.types import BaseModel
from typing import List, Optional
from typing_extensions import NotRequired, TypedDict


class CategoriesTypedDict(TypedDict):
    title: NotRequired[str]
    url: NotRequired[str]


class Categories(BaseModel):
    title: Optional[str] = None

    url: Optional[str] = None


class YelpBusinessTypedDict(TypedDict):
    business_id: NotRequired[str]
    r"""Unique identifier for the business"""
    alias: NotRequired[str]
    r"""A unique identifier used in the URL for the business"""
    name: NotRequired[str]
    r"""The name of the business"""
    address: NotRequired[str]
    r"""The physical address of the business"""
    website: NotRequired[str]
    r"""The website URL of the business"""
    business_page_link: NotRequired[str]
    r"""The link to the business's page on the platform"""
    categories: NotRequired[List[CategoriesTypedDict]]
    r"""List of categories that the business falls under"""
    rating: NotRequired[float]
    r"""Average rating of the business"""
    review_count: NotRequired[int]
    r"""Total number of reviews for the business"""
    highlights: NotRequired[List[str]]
    r"""Highlights or features of the business"""
    service_area: NotRequired[str]
    r"""The area where the business provides services"""
    neighborhoods: NotRequired[List[str]]
    r"""List of neighborhoods where the business is located"""


class YelpBusiness(BaseModel):
    business_id: Optional[str] = None
    r"""Unique identifier for the business"""

    alias: Optional[str] = None
    r"""A unique identifier used in the URL for the business"""

    name: Optional[str] = None
    r"""The name of the business"""

    address: Optional[str] = None
    r"""The physical address of the business"""

    website: Optional[str] = None
    r"""The website URL of the business"""

    business_page_link: Optional[str] = None
    r"""The link to the business's page on the platform"""

    categories: Optional[List[Categories]] = None
    r"""List of categories that the business falls under"""

    rating: Optional[float] = None
    r"""Average rating of the business"""

    review_count: Optional[int] = None
    r"""Total number of reviews for the business"""

    highlights: Optional[List[str]] = None
    r"""Highlights or features of the business"""

    service_area: Optional[str] = None
    r"""The area where the business provides services"""

    neighborhoods: Optional[List[str]] = None
    r"""List of neighborhoods where the business is located"""
