"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from exfunc.types import BaseModel
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class ZillowPriceHistoryEventTypedDict(TypedDict):
    date_: NotRequired[str]
    r"""The date of the price change"""
    price: NotRequired[float]
    r"""The price of the property at the given date"""
    time_epoch: NotRequired[int]
    r"""Time of the price change in epoch format"""
    price_per_square_foot: NotRequired[float]
    r"""Price per square foot at the given date"""
    price_change_rate: NotRequired[float]
    r"""Rate of change in price over time"""
    event: NotRequired[str]
    r"""Description of the event (e.g., price increase, price decrease)"""
    source: NotRequired[str]
    r"""Source of the price history data"""
    is_rental: NotRequired[bool]
    r"""Indicates if the property is a rental"""


class ZillowPriceHistoryEvent(BaseModel):
    date_: Annotated[Optional[str], pydantic.Field(alias="date")] = None
    r"""The date of the price change"""

    price: Optional[float] = None
    r"""The price of the property at the given date"""

    time_epoch: Optional[int] = None
    r"""Time of the price change in epoch format"""

    price_per_square_foot: Optional[float] = None
    r"""Price per square foot at the given date"""

    price_change_rate: Optional[float] = None
    r"""Rate of change in price over time"""

    event: Optional[str] = None
    r"""Description of the event (e.g., price increase, price decrease)"""

    source: Optional[str] = None
    r"""Source of the price history data"""

    is_rental: Optional[bool] = None
    r"""Indicates if the property is a rental"""
